(function() {

	var c = false;
	var a = false;
	var r = false;

	browser.runtime.sendMessage({
		text: 'state'
	});

	browser.runtime.onMessage.addListener(function(request) {
		if (request.c === 'true') {
			c = true;
		}
		if (request.a === 'true') {
			a = true;
		}
		state();
	});

	document.querySelector('.enable-copy').onclick = function () {
		enableCopy();
	};

	document.querySelector('.abs-mode').onclick = function () {
		absoluteMode();
	};

	document.querySelector('.reload').onclick = function () {
		browser.tabs.reload();
		window.close();
	};

	document.querySelector('.settings').addEventListener('click', function() {	
		browser.tabs.create({
			url: 'pages/options.html'
		});
		window.close();
	});

	document.addEventListener('dragstart', function(e) {
		e.preventDefault();
	});

	browser.tabs.query({active: true, currentWindow: true}, function(tabs) {
		var url = tabs[0].url;
		if (!/^https?:\/\//i.test(url)) {
			document.querySelector('.enable-copy').remove();
			document.querySelector('.abs-mode').remove();
			document.querySelector('.description').remove();
			document.querySelector('.state').style = 'color: #a98e8e; height: 150px; display: grid; align-items: center;';
			document.querySelector('.state span').innerHTML = 'Unable to run on this page';
		}
	});

	function enableCopy(message) {
		if (c === false) {
			c = true;
			message = {
				text: 'c-true'
			};
			browser.runtime.sendMessage(message);
		} else {
			c = false;
			r = true;
			message = {
				text: 'c-false'
			};
			browser.runtime.sendMessage(message);
		}
		state(r);
	}

	function absoluteMode(message) {
		if (a == false) {
			a = true;
			message = {
				text: 'a-true'
			};
			browser.runtime.sendMessage(message);
		} else {
			a = false;
			r = true;
			message = {
				text: 'a-false'
			};
			browser.runtime.sendMessage(message);
		}
		state(r);
	}

	function state(r) {
		if (c === true) {
			document.querySelector('.enable-copy img').src = 'images/on.png';
		} else {
			document.querySelector('.enable-copy img').src = 'images/off.png';
			if (r == true)
				reload();
		}
		if (a === true) {
			document.querySelector('.abs-mode img').src = 'images/on.png';
		} else {
			document.querySelector('.abs-mode img').src = 'images/off.png';
			if (r == true)
				reload();
		}
		if (c === false && a === false) {
			document.querySelector('.state span').innerHTML = 'Not Enabled';
		} else {
			document.querySelector('.state span').innerHTML = 'Enabled';
		}
	}

	function reload() {
		document.querySelector('.reload').style.display = 'flex';
	}

})();